      PROGRAM XMA

c    Il programma segue i grafici del report di GIORDANO

c Files di input :
c    cla3d.inp       curva di portanza dell'ala  alfa - CLw
c    geom.inp        dati del velivolo (corde, distanze, ecc)
c    diafi.inp       valori di FI letti dai diagrammi a 70, 80 e 90


      real amcp(5)
      real amcn(5)

      real ffi(10,10)
 
      real al3d(300),cl3dw(300)
 
      real ffiv(100)

      real alfav(100)
      real epsv(100)
      real CLwv(100)
      real dedav(100)
      real amwv(100)
      real amv(100)

	real dFIda(100)

	real dCLda(100)
      real mo,moa

      pi=acos(-1.0)

      OPEN(8,File='cla3d.inp')
      read(8,*) np
      DO i=1,np
      read(8,*) al3d(i),Cl3dw(i)
      END DO
      CLOSE(8)

      OPEN(8,File='geom.inp')
      read(8,*) aiw
      read(8,*) cw
      read(8,*) ch
      read(8,*) xlew
      read(8,*) xleh
      read(8,*) dzwh
      read(8,*) bw
      read(8,*) AR
      read(8,*) alaw
      rr=1./alaw
      CLOSE(8)


      OPEN(10,File='down.cal')


      dzte=0.75*cw*sin(aiw*pi/180)

      xo=xleh-xlew-cw/4.+ch/4.
      xoa=100*2*xo/bw
      mo=dzwh+dzte
      moa=100*mo*2/bw
      d=mo**2.0+(xo-0.75*cw*cos(aiw*pi/180))**2.0
      d=d**0.5
      da=100*d*2/bw
      fi=atan(-mo/(xo-0.75*cw*cos(aiw*pi/180)))

      fideg=fi*180/pi

      cw34a=cw*0.75*2*100/bw

           
      write(10,*) 'xo=',xo,'   % bw/2  =',xoa
      write(10,*) 'mo=',mo,'   % bw/2  =',moa
      write(10,*) 'd =',d,'   % bw/2  =',da
      write(10,*) 'fi=',fideg

      write(*,*) 'xo=',xo,'   % bw/2  =',xoa
      write(*,*) 'mo=',mo,'   % bw/2  =',moa
      write(*,*) 'd =',d,'   % bw/2  =',da
      write(*,*) 'fi=',fideg
      
        OPEN(11,File='diafi.inp')
        read(11,*) amwCL1
        DO j=1,3
        read(11,*) dum
        DO jj=1,4
        read(11,*) ffi(jj,j)
        END DO
        END DO
        CLOSE(11)


      write(*,*) 'alfa iniziale ='
      read(*,*) alfai
      write(*,*) 'alfa finale ='
      read(*,*) alfaf
      write(*,*) 'numero angoli ='
      read(*,*) nalfa



      
      if(nalfa.eq.1) then
      dalfa=0.
      else
      dalfa=(alfaf-alfai)/(nalfa-1)
      end if

      DO ia=1,nalfa
      alfav(ia)=alfai+(ia-1)*dalfa
      write(*,*) ia,alfav(ia)
      END DO

      
       DO ia=1,nalfa
       
       alfa=alfav(ia)
   
      
       write(10,*) 'alfa=',alfa
      
c      write(*,*) ' assegna   alpha, iw deg.'
c      read(*,*) alfa,aiw


c      aiw=3.6
      pi=acos(-1.0)
      alphar=alfa*pi/180
      aiwr=aiw*pi/180
c      d=0.59
c      cw34=0.215
c      fi=12.36
      
      
      fir=fideg*pi/180
      
      x=(da*cos(alphar+fir)+cw34a*cos(alphar+fir))
      am=-da*sin(alphar+fir)
      

      write(10,*) ' x perc b/2   =',x
      write(10,*) '  m  perc b/2 =',am

      amv(ia)=am
      
      alfaw=alfa+aiw
      DO i=1,np-1
      al3d1=al3d(i)
      al3d2=al3d(i+1)
      if((alfaw.ge.al3d1).and.(alfaw.le.al3d2)) then
      perc=(alfaw-al3d1)/(al3d2-al3d1)
      CLw=Cl3dw(i)+(Cl3dw(i+1)-Cl3dw(i))*perc
      end if
      END DO
      

      write(10,*) 'CLw=',CLw
      write(*,*) 'CLw=',CLw

c      read(*,*) CLw
        

      CLwv(ia)=CLw

c trovo FI numerico
        hcor1=(1.324)/(rr-0.5)-0.06*(rr**2.)+8.41
        hcor2=-((0.22)/(rr-0.5)-0.01*(rr**2)+0.215)*AR
        hcor=(hcor1+hcor2)*CLw

        absmh=abs(am+hcor)

        write(*,*) 'x % b/2 =',x
        write(*,*) 'm       =',am
        write(*,*) 'h       =',hcor
        write(*,*) 'ABS(m-h)=',absmh

        f1=21.677/rr+1.833*rr+26.5
        f2=0.75+1.425/(4*rr-1)
        f31=(0.26/(0.7-rr)+0.1625*rr-0.874)/10000.
        f32=((0.66*rr-1.4)/((0.8-rr)*(6-rr))-0.9)/100.
        f3=f31*(absmh**2.0)+f32*absmh+1
        f4=(0.025*AR-0.4)*(x-80)*0.1

	

	write(10,*) 'CALCOLI NUMERICI '
	write(10,*) ' ABS (m+h)  =',absmh
	write(10,*) ' f1 =',f1
        write(10,*) ' f3 =',f3
      

        f2d=AR**f2
        FICOR=f1*f3/f2d+f4

	write(10,*) ' f2d=',f2d
        write(10,*) ' f4 =',f4



cfab  amwCL1 e' dato in input nel file 'diafi.dat'

      amw=amwCL1*abs(CLw)
c      dam=10*abs(CLw)
	dam=10.0

      amwv(ia)=amw
      
	write(10,*) ' h (% b/2) = ',-amw
	write(10,*) ' h    NUM  = ',hcor

	amwv(ia)=-hcor
        

      amcp(1)=amw
      amcp(2)=amw+dam
      amcp(3)=amw+2*dam
      amcp(4)=amw+3*dam

      amcn(1)=amw
      amcn(2)=amw-dam
      amcn(3)=amw-2*dam
      amcn(4)=amw-3*dam

      DO i=1,4
      write(10,*) amcp(i),amcn(i)
      write(*,*) amcp(i),amcn(i)
      END DO
      
      if(am.gt.amw) then
      write(10,*) 'piano coda al di sopra della scia'
      write(*,*) 'piano coda al di sopra della scia'
      DO i=1,3
      am1=amcp(i)
      am2=amcp(i+1)
      if((am.ge.am1).and.(am.le.am2)) then
      write(10,*) 'piano tra curve  ',i,i+1
      perc=(am-am1)/(am2-am1)
      write(10,*) 'perc. dalla curva ',i,perc
      iac=i
      end if
      END DO
      if(am.gt.amcp(4)) then
      perc=(am-amcp(3))/(amcp(4)-amcp(3))
      write(10,*) 'perc dalla curva 3 =',perc
      iac=3
      end if
      else
      write(10,*) 'piano coda al di sotto della scia'
      write(*,*) 'piano coda al di sotto della scia'
      DO i=1,3
      am1=amcn(i)
      am2=amcn(i+1)
      if((am.le.am1).and.(am.ge.am2)) then
      write(10,*) 'piano tra curve  ',i,i+1
      iac=i
      perc=(am-am1)/(am2-am1)
      write(10,*) 'perc. dalla curva ',i,perc
      end if
      END DO
      if(am.lt.amcn(4)) then
      perc=(am-amcn(3))/(amcn(4)-amcn(3))
      write(10,*) 'perc dalla curva 3 =',perc
      iac=3
      end if
      end if



c       ffi(1,1)=4.80
c       ffi(2,1)=4.60
c       ffi(3,1)=4.30
c       ffi(4,1)=3.80

c       ffi(1,2)=4.65
c       ffi(2,2)=4.45
c       ffi(3,2)=4.20
c       ffi(4,2)=3.75

c       ffi(1,3)=4.50
c       ffi(2,3)=4.27
c       ffi(3,3)=4.05
c       ffi(4,3)=3.67

c	write(10,*) 'iac=',iac
c        write(10,*) 'ffi (iac,70)=',ffi(iac,1)
c        write(10,*) 'perc=',perc
c        DO jj=1,4
c        write(10,*) ffi(jj,1)
c        END DO

       ffi70=ffi(iac,1)+(ffi(iac+1,1)-ffi(iac,1))*perc
       ffi80=ffi(iac,2)+(ffi(iac+1,2)-ffi(iac,2))*perc
       ffi90=ffi(iac,3)+(ffi(iac+1,3)-ffi(iac,3))*perc

      write(10,*) ' FI         70         80         90 % ='
      write(10,'(3(F9.3))') ffi70,ffi80,ffi90

	IF(X.lt.70) x=70
	if(x.gt.90) x=90


      if((x.ge.70).and.(x.le.80)) then
      ffic=ffi70+(x-70)*0.1*(ffi80-ffi70)
      end if
      if((x.ge.80).and.(x.le.90)) then
      ffic=ffi80+(x-80)*0.1*(ffi90-ffi80)
      end if

      write(10,'(A10,F8.3)') ' FI =',ffic
      write(10,'(A10,F8.3)') ' FI NUM=',ficor
      write(*,'(A10,F8.3)') ' FI =',ffic
      write(*,'(A10,F8.3)') ' FI NUM=',FICOR

c        ffic=ficor
      ffiv(ia)=ffic

      eps=ffic*CLw
      epsv(ia)=eps
      write(10,'(A10,F8.3)') ' EPS =',eps
      write(*,'(A10,F8.3)') ' EPS =',eps
      
c      write(*,*) ' alfa   ,  eps prec='
c      read(*,*) alfap,epsp

c      deda=(eps-epsp)/(alfa-alfap)
      
c      write(*,'(A10,F8.3)') 'deps/da  =',deda

c chiusura ciclo in alfa
      END DO
      

      OPEN(9,File='downw.out')
       write(9,'(A1,A140)') '#','   alfa      alfaw        CLw      eps       
     >     de/da      m      mw      m-h       FI      dFI/da   deda1    
     >  deda2'

      if(nalfa.gt.1) then
      DO ia=1,nalfa-1
      dedav(ia)=(epsv(ia+1)-epsv(ia))/(alfav(ia+1)-alfav(ia))
      dfida(ia)=(ffiv(ia+1)-ffiv(ia))/(alfav(ia+1)-alfav(ia))
      dCLda(ia)=(CLwv(ia+1)-CLwv(ia))/(ALFAV(IA+1)-alfav(ia))	
      END DO
      dedav(nalfa)=dedav(nalfa-1)
      dfida(nalfa)=dfida(nalfa-1)
      dCLda(nalfa)=dCLda(nalfa-1)
      end if
      
      DO ia=1,nalfa
      amh=amv(ia)-amwv(ia)
      alfaw=alfav(ia)+aiw
      deda1=CLwv(ia)*dfida(ia)
      deda2=ffiv(ia)*dCLda(ia)	
      write(9,9001) alfav(ia),alfaw,CLwv(ia),epsv(ia),dedav(ia),amv(ia),
     > amwv(ia),amh,ffiv(ia),dfida(ia),dCLda(ia),deda1,deda2 
      END DO

      CLOSE(10)
      CLOSE(9)


9001   format(1x,13(F9.4,1x))            

      stop
      end
      

